const gulp = require("gulp");
const tsc = require("gulp-typescript");
const tsProject = tsc.createProject("./tsconfig.json");
var embedTemplates = require('gulp-angular-embed-templates');
var concat = require('gulp-concat');
var umd = require('gulp-umd');
const webpack = require('webpack');
const webpackConfig = require('./webpack.config');
const gutil = require('gulp-util');

gulp.task('app.build', function () {
    gulp.src('src/**/*.ts')
        .pipe(embedTemplates({ sourceType: 'ts' }))
        .pipe(tsProject())
        .pipe(gulp.dest('./build/js'));
});

gulp.task('app.bundle', function () {
    gulp.src('build/**/*.js')
        .pipe(concat('bundle.min.js'))
        //    .pipe(uglify())
        .pipe(gulp.dest('bundles'));
});

gulp.task('umd', function () {
    return gulp.src('build/**/*.js')
        .pipe(umd())
        .pipe(gulp.dest('bundles'));
});

gulp.task('webpack', function (callback) {
    var myConfig = Object.create(webpackConfig);
    myConfig.plugins = [
        new webpack.optimize.DedupePlugin(),
        new webpack.optimize.UglifyJsPlugin()
    ];

    // run webpack
    webpack(myConfig, function (err, stats) {
        if (err) throw new gutil.PluginError('webpack', err);
        gutil.log('[webpack]', stats.toString({
            colors: true,
            progress: true
        }));
        callback();
    });
});

